package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.Counter;

/**
 * PUT /{server}/counters/{counter}
 */
public class PerforceSetCounterRoute implements
        spark.Route,
        P4Methods,
        HasGson,
        ModelConversion,
        UsesJsonRequests,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String counter = request.params("counter");

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            Counter counterModel = readModel(request, Counter.class);

            return toCommandResponse(exec(serverHandle,
                    "counter", "-f", counter, counterModel.getValue()));
        });
    }
}
